<template>
    <div class="head-section">
        <div class="header-contaier">
            <div class="header-side-inner">
                <!-- <van-icon
                @click="back"
                name="arrow-left"
                color="#fff"
                size="20px"
            /> -->
            </div>
            <div class="header-title-inner">
                <span class="header-title">{{ currentKey.name }}</span>
            </div>
            <div class="header-side-inner right">
                <span
                    class="header-sub-title"
                    @click="changeMenu(currentKey.changeKey)"
                    >{{ currentKey.subName }}</span
                >
            </div>
        </div>
        <div class="con-box">
            <div class="zl-item" @click="handClick(tabsList[0], 0)">
                {{ tabsList[0].lable }}
            </div>
            <ul>
                <li
                    v-for="(item, index) in tabsList.slice(1)"
                    :key="index"
                    :class="[{active: index == 3}]"
                    @click="handClick(item, index)"
                >
                    <span>{{ item.lable }}</span>
                </li>
            </ul>
        </div>
        <div class="section-select-container">
            <div class="select-btn-outer">
                <div
                    class="select-btn flex-center"
                    @click="handleSelectShow('Year')"
                >
                    <span>{{ activeSearchDateYear.name }}</span>
                    <i
                        class="el-icon-caret-bottom"
                        :class="{
                            trans: showSelectYear,
                        }"
                    ></i>
                </div>
                <div class="select-options" v-if="showSelectYear">
                    <div
                        class="select-option"
                        :class="{
                            active: activeSearchDateYear.value == item.value,
                        }"
                        v-for="(item, index) in searchDateYear"
                        :key="item.value"
                        @click="handleSelectDate(index, item, 'Year')"
                    >
                        {{ item.name }}
                    </div>
                </div>
            </div>
            <div class="select-btn-outer" v-if="pageName == 'districtReform'">
                <div
                    class="select-btn flex-center"
                    @click="handleSelectShow('Quarter')"
                >
                    <span>{{ activeSearchDateQuarter.name }}</span>
                    <i
                        class="el-icon-caret-bottom"
                        :class="{
                            trans: showSelectQuarter,
                        }"
                    ></i>
                </div>
                <div class="select-options" v-if="showSelectQuarter">
                    <div
                        class="select-option"
                        :class="{
                            active: activeSearchDateQuarter.value == item.value,
                        }"
                        v-for="(item, index) in searchDateQuarter"
                        :key="item.value"
                        @click="handleSelectDate(index, item, 'Quarter')"
                    >
                        {{ item.name }}
                    </div>
                </div>
            </div>
            <div class="select-btn-outer" v-else>
                <div
                    class="select-btn flex-center"
                    @click="handleSelectShow('Month')"
                >
                    <span>{{ activeSearchDateMonth.name }}</span>
                    <i
                        class="el-icon-caret-bottom"
                        :class="{
                            trans: showSelectMonth,
                        }"
                    ></i>
                </div>
                <div class="select-options" v-if="showSelectMonth">
                    <div
                        class="select-option"
                        :class="{
                            active: activeSearchDateMonth.value == item.value,
                        }"
                        v-for="(item, index) in searchDateMonth"
                        :key="item.value"
                        @click="handleSelectDate(index, item, 'Month')"
                    >
                        {{ item.name }}
                    </div>
                </div>
            </div>
            <div
                class="select-options-mask"
                @click="handleSelectHidden"
                v-if="showSelectQuarter || showSelectYear || showSelectMonth"
            ></div>
        </div>
    </div>
</template>

<script>
export default {
    name: 'headSection',
    props: {
        pageName: {
            type: String,
            default: 'MajorProjects',
        },
    },
    data() {
        return {
            currentKey: {
                name: '重大改革项目报表',
                path: '/MajorProjectsMobile',
                key: 'MajorProjectsMobile',
                changeKey: 'DistrictReformMobile',
                subName: '区县报表',
            },
            majorProjectsMobile: {
                name: '重大改革项目报表',
                path: '/MajorProjectsMobile',
                key: 'MajorProjectsMobile',
                changeKey: 'DistrictReformMobile',
                subName: '区县报表',
            },
            districtReformMobile: {
                name: '区县改革报表',
                path: '/DistrictReformMobile',
                key: 'DistrictReformMobile',
                changeKey: 'MajorProjectsMobile',
                subName: '重大项目',
            },
            showSelectQuarter: false,

            searchDateQuarter: [
                {
                    value: 1,
                    name: '一季度',
                },
                {
                    value: 2,
                    name: '二季度',
                },
                {
                    value: 3,
                    name: '三季度',
                },
                {
                    value: 4,
                    name: '四季度',
                },
                {
                    value: 0,
                    name: '年度',
                },
            ],
            searchDateMonth: [
                {
                    value: 1,
                    name: '1月',
                },
                {
                    value: 2,
                    name: '2月',
                },
                {
                    value: 3,
                    name: '3月',
                },
                {
                    value: 4,
                    name: '4月',
                },
                {
                    value: 5,
                    name: '5月',
                },
                {
                    value: 6,
                    name: '6月',
                },
                {
                    value: 7,
                    name: '7月',
                },
                {
                    value: 8,
                    name: '8月',
                },
                {
                    value: 9,
                    name: '9月',
                },
                {
                    value: 10,
                    name: '10月',
                },
                {
                    value: 11,
                    name: '11月',
                },
                {
                    value: 12,
                    name: '12月',
                },
            ],
            showSelectYear: false,
            showSelectMonth: false,
            activeSearchDateYear: {
                value: 2023,
                name: '2023年',
            },
            activeSearchDateQuarter: {
                value: 1,
                name: '一季度',
            },
            activeSearchDateMonth: {
                value: 1,
                name: '一月',
            },
            searchDateYear: [],
            // 最后的标识符是为了跳转带参数方便拼接 不要删除
            tabsList: [
                {
                    lable: '总览',
                    value: 'dj',
                    name: '0',
                    link: 'http://23.99.8.1:8080/fvue/yddzl?',
                },
                {
                    lable: '党建',
                    value: 'dj',
                    name: '1',
                    link: 'http://23.99.8.1:8080/fvue/ydddj?',
                },
                {
                    lable: '经济',
                    value: 'jj',
                    name: '2',
                    link: 'http://23.99.219.238:10000/#/pages/index/index?report=jingji&',
                },
                {
                    lable: '平安',
                    value: 'pa',
                    name: '3',
                    link: 'http://23.211.13.179:32000/#/questionListSeven?',
                },
                {
                    lable: '改革',
                    value: 'gg',
                    name: '4',
                    link: 'http://23.99.8.2:8090/fvue/Jump?type=mobile&',
                },
                {
                    lable: '创新',
                    value: 'cx',
                    name: '5',
                    link: 'http://23.99.220.103:8200/innovation-mobile/#/index?',
                },
                {
                    lable: '生态',
                    value: 'st',
                    name: '6',
                    link: 'http://23.213.61.6:8077/h5?',
                },
                {
                    lable: '文化',
                    value: 'wh',
                    name: '7',
                    link: 'http://23.99.8.168:8090/h5/index?',
                },
                {
                    lable: '民生',
                    value: 'ms',
                    name: '8',
                    link: 'http://23.99.219.238:10000/#/pages/index/index?report=minsheng&',
                },
            ],
            nowQuarter: {},
            month: null,
            year: null,
            quarter: null,
        }
    },
    watch: {
        pageName: {
            handler: function (newVal, oldVal) {
                console.log(newVal)
                this.currentKey = this[`${newVal}Mobile`]
            },
            immediate: true,
        },
    },
    mounted() {
        this.initYearOption()
        let searchDate = sessionStorage.getItem('searchDate')
        if (searchDate) {
            searchDate = JSON.parse(searchDate)
            this.year = searchDate.year
            this.quarter = searchDate.quarter
            this.month = searchDate.month
            this.checkQuarter(this.year, this.quarter)
        } else {
            this.checkQuarter()
        }
    },
    methods: {
        changeMenu(key) {
            this.$router.push({
                path: '/' + key,
            })
        },
        handleSelectHidden() {
            this.showSelectQuarter = false
            this.showSelectYear = false
        },
        handleSelectDate(i, item, type) {
            this[`activeSearchDate${type}`] = this[`searchDate${type}`][i]
            this[`showSelect${type}`] = !this[`showSelect${type}`]
            if (type == 'Year') {
                this.year = item.value
            } else if (type == 'Quarter') {
                this.quarter = item.value
            } else if (type == 'Month') {
                this.month = item.value
            }
            let searchDate = {
                year: this.year,
                quarter: this.quarter,
                month: this.month,
            }
            sessionStorage.setItem('searchDate', JSON.stringify(searchDate))
            this.$bus.$emit('changeDate', searchDate)
        },
        handleSelectShow(type) {
            this[`showSelect${type}`] = !this[`showSelect${type}`]
        },
        handClick(item, index) {
            let userinfo
            userinfo = sessionStorage.getItem('eightPageUser')
            let query = `skipflag=1&userinfo=${encodeURIComponent(userinfo)}`
            if (index !== 3) {
                console.log(item.link + query)
                window.location.href = item.link + query
            }
        },
        initYearOption() {
            let year = new Date().getFullYear()
            for (let i = 0; i < 5; i++) {
                this.searchDateYear.push({
                    value: year - i,
                    name: year - i + '年',
                })
            }
        },
        checkQuarter(yearVal, quarterVal) {
            console.log(yearVal);
            let year, month, quarter, hanzi
            if (yearVal) {
                year = yearVal
                quarter = quarterVal
                hanzi = quarterVal=='0' ? '年' : this.quarterFormatH(quarter) + '季'
            } else {
                year = new Date().getFullYear() -1
                month = new Date().getMonth() + 1
                quarter = this.quarterFormat(month)[0]
                hanzi = this.quarterFormat(month)[1] + '季'
            }
            // 下拉框选中的季度
            this.activeSearchDateQuarter = {
                // value: quarter,
                // name: hanzi + '度',
                value: 0,
                name: '年度',
            }
            this.activeSearchDateYear = {
                value: year,
                name: year + '年',
            }
            this.quarter = quarter
            this.year = year
        },
        quarterFormatH(quarter) {
            let hanzi
            if (quarter == 1) {
                hanzi = '一'
            } else if (quarter == 2) {
                hanzi = '二'
            } else if (quarter == 3) {
                hanzi = '三'
            } else if (quarter == 4) {
                hanzi = '四'
            }
            return hanzi
        },
        quarterFormat(month) {
            let quarter, hanzi
            if (month <= 3) {
                quarter = 1
                hanzi = '一'
            } else if (month <= 6) {
                quarter = 2
                hanzi = '二'
            } else if (month <= 9) {
                quarter = 3
                hanzi = '三'
            } else if (month <= 12) {
                quarter = 4
                hanzi = '四'
            }
            return [quarter, hanzi]
        },
    },
}
</script>

<style lang='scss' scoped>
@import './css/mobileScreen.scss';
.head-section{
    width: 100%;
}
.header-contaier{
    height: 44PX;
    background-color: #0087fd;
    display: flex;
    padding: 0 15PX;
    justify-content: space-between;
    align-items: center;
}
.header-side-inner{
    width: 60PX;
}
.header-side-inner.right{
    text-align: right;
}
.header-title{
    color: #fff;
    font-size: 18PX;
}
.header-sub-title{
    color: #fff;
    font-size: 12PX;
}
</style>